package unlh.graph.datastructure;

import org.graphstream.graph.Node;

import java.util.*;

public class PrioritaryLine implements PrioritaryLineInterface {

    HashMap<Node, Double> map;

    /**
     * create an empty list
     */
    @Override
    public void init() {
        map = new HashMap<Node, Double>();
    }

    @Override
    public Boolean empty() throws Exception {
        if (map != null) {
            return map.isEmpty();
        } else {
            throw new Exception("Calling empty method on non initialized Prioritary line");
        }
    }

    /**
     * Add a node to the priority
     *
     * @param node
     * @param p
     * @return
     */
    @Override
    public PrioritaryLine add(Node node, Double p) {
        if (map != null) {
            map.put(node, p);
            return this;
        }
        return null;
    }

    /**
     * Clear the map attribute list
     *
     * @return
     */
    @Override
    public PrioritaryLineInterface clear() {
        if (map != null) {
            map.clear();
            return this;
        }
        return null;
    }

    /**
     * return the length of the list
     *
     * @return
     */
    @Override
    public Double length() {
        if (map != null) {
            return Double.valueOf(map.size());
        }
        return null;
    }

    /**
     * retrieve Element with the priority minimum
     *
     * @return
     */
    @Override
    public Node extractMin() {
        // check list is empty or not
        if (map == null || map.size() ==0) {
            return null;
        }
        return map.entrySet()
                .stream()
                .min(Comparator.comparingDouble(Map.Entry::getValue))
                .get()
                .getKey();
    }
}
